# 1 "<stdin>"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "<stdin>"
program Conversion

  use sep

  implicit none

  integer :: ix, ip, ih, iz
  integer :: nx, nh, nz
  real :: x, p, h, z, t, maxoffset, maxangle
  real :: dx, dp, dh, dz
  real :: ox, op, oh, oz
  integer :: itl, itr
  real :: cl, cr, tt
  logical :: adj

  real, dimension(:,:,:), allocatable :: offset, angle

  call sep_init()

  call from_history("n1", nz)
  call from_history("d1", dz)
  call from_history("o1", oz)
  call from_history("n2", nx)
  call from_history("d2", ox)
  call from_history("o2", dx)
  call from_history("n3", nh)

  call to_history("n1", nz)
  call to_history("d1", dz)
  call to_history("o1", oz)
  call to_history("n2", nx)
  call to_history("d2", ox)
  call to_history("o2", dx)
  call to_history("n3", nh)

  allocate(offset(nz,nx,nh), angle(nz,nx,nh))

  call from_param("adj", adj)

  if(adj) then
    call from_history("d3", dh)
    call from_history("o3", oh)
    call from_param("maxangle", maxangle)
    op = -1.*maxangle
    dp = maxangle*2/(nh-1)
    call to_history("d3", dp)
    call to_history("o3", op)
    call sep_read(offset)
  else
    call from_history("d3", dp)
    call from_history("o3", op)
    call from_param("maxoffset", maxoffset)
    oh = -1.*maxoffset
    dh = maxoffset*2/(nh-1)
    call to_history("d3", dh)
    call to_history("o3", oh)
    call sep_read(angle)
  end if

  do ix = 1,nx
    do ip = 1,nh
      p = op + (ip-1) * dp
      do ih = 1,nh
        h = oh + (ih-1) * dh
        do iz = 1,nz
          z = oz + (iz-1) * dz
          t = z + tan(p*3.14159265/180.0)*h

          tt = 1.0 + (t-oz)/dz
          itr = ceiling(tt)
          itl = floor(tt)
          cr = tt - itl
          cl = 1.0 - cr
          if( itr >=1 .and. itr <= nz) then
            if ( adj) then
              angle(iz,ix,ip) = angle(iz,ix,ip) + cl*offset(itl,ix,ih)+cr*offset(itr,ix,ih)
            else
              offset(itl,ix,ih) = offset(itl,ix,ih) + cl*angle(iz,ix,ip)
              offset(itr,ix,ih) = offset(itr,ix,ih) + cr*angle(iz,ix,ip)
            end if
          end if
        end do
      end do
    end do
  end do

  if(adj) then
    call sep_write(angle)
  else
    call sep_write(offset)
  end if

  call sep_close()
end program
