program Xcorr

  use sep

  implicit none

  integer                              :: n1, n2, n3, i, j, k, l, p, lag, window
  integer                              :: n1l
  real                                 :: o1, d1, o2, d2, o3, d3
  real, allocatable, dimension(:,:,:)  :: data, m1, m2
  real, allocatable, dimension(:)      :: datal, m1l, m2l, wt

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3, 1)
  call from_history("o3", o3, 0.0)
  call from_history("d3", d3, 1.0)

  call from_param("n1l", n1l)

  if(mod(n1l,2) .eq. 0) n1l=n1l+1

  allocate(data(n1,n2,n3), m1(n1,n2,n3), m2(n1,n2,n3))
  allocate(datal(2*n1l-1), m1l(n1l), m2l(n1l), wt(n1l))

  call sep_read(m1)
  call sep_read(m2, "filter")

  window = n1l-1

  do i=1,n1l
    lag = i - window/2 - 1
    wt(i) = exp(-1.0*lag*lag/window)
  end do

  data = 0.

  do l=1,n3
    do k=1,n2
      do p=1+window/2,n1-window/2

        m1l = m1(p-window/2:p+window/2,k,l)*wt
        m2l = m2(p-window/2:p+window/2,k,l)*wt
        datal = 0.

        do j=1,window+1
          lag = j - window - 1
          do i=1,n1l+lag
            datal(j) = datal(j) + m1l(i-lag)*m2l(i)
          end do
        end do
        do j=window+2,2*window+1
          lag = j - window - 1
          do i=1+lag,n1l
            datal(j) = datal(j) + m1l(i-lag)*m2l(i)
          end do
        end do

        if(maxval(abs(datal))>0.) data(p,k,l) = sum(maxloc(abs(datal)))-window

      end do
    end do
  end do

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)
  call to_history("n3", n3)
  call to_history("o3", o3)
  call to_history("d3", d3)

  call sep_write(data)

  call sep_close()

end program
